
_main:

;PWM_LED.mbas,20 :: 		main:
;PWM_LED.mbas,22 :: 		CMCON = 0x07             ' Disable comparators    remove if 18F452
	MOVLW       7
	MOVWF       CMCON+0 
;PWM_LED.mbas,23 :: 		ADCON1 = 0x0F            ' All pins as digital    0x07 for 18F452
	MOVLW       15
	MOVWF       ADCON1+0 
;PWM_LED.mbas,24 :: 		TRISA = 0                ' Set all pins as output
	CLRF        TRISA+0 
;PWM_LED.mbas,25 :: 		TRISA.3 = 1              ' PORTA.3 input PB
	BSF         TRISA+0, 3 
;PWM_LED.mbas,26 :: 		TRISC = 0                ' designate PORTC pins as output
	CLRF        TRISC+0 
;PWM_LED.mbas,27 :: 		PORTC = 0                ' set PORTC to 0
	CLRF        PORTC+0 
;PWM_LED.mbas,29 :: 		increase = 1
	BSF         _increase+0, BitPos(_increase+0) 
;PWM_LED.mbas,30 :: 		speed = 20
	MOVLW       20
	MOVWF       _speed+0 
;PWM_LED.mbas,31 :: 		duty_cycle = 50
	MOVLW       50
	MOVWF       _duty_cycle+0 
;PWM_LED.mbas,33 :: 		if EEPROM_READ(0) = %10101010 then    ' test if first time
	CLRF        FARG_EEPROM_Read_address+0 
	CLRF        FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	XORLW       170
	BTFSS       STATUS+0, 2 
	GOTO        L__main2
;PWM_LED.mbas,34 :: 		duty_cycle = EEPROM_READ(1)          ' yes retrieve all eeprom data
	MOVLW       1
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _duty_cycle+0 
;PWM_LED.mbas,35 :: 		increase = EEPROM_READ(2)
	MOVLW       2
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	BTFSC       R0, 0 
	GOTO        L__main43
	BCF         _increase+0, BitPos(_increase+0) 
	GOTO        L__main44
L__main43:
	BSF         _increase+0, BitPos(_increase+0) 
L__main44:
;PWM_LED.mbas,36 :: 		duty_cycle_mem = EEPROM_READ(3)
	MOVLW       3
	MOVWF       FARG_EEPROM_Read_address+0 
	MOVLW       0
	MOVWF       FARG_EEPROM_Read_address+1 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _duty_cycle_mem+0 
L__main2:
;PWM_LED.mbas,38 :: 		delay_ms (75)                        ' EEPROM read/write delay
	MOVLW       244
	MOVWF       R12, 0
	MOVLW       128
	MOVWF       R13, 0
L__main4:
	DECFSZ      R13, 1, 1
	BRA         L__main4
	DECFSZ      R12, 1, 1
	BRA         L__main4
	NOP
;PWM_LED.mbas,39 :: 		EEPROM_WRITE (0,%10101010)           ' put in EEPROM data flag
	CLRF        FARG_EEPROM_Write_address+0 
	MOVLW       170
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;PWM_LED.mbas,40 :: 		PWM2_Init(5000)          ' Initialize PWM2 module at 5kHz PORTC.1
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	BSF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       124
	MOVWF       PR2+0, 0
	CALL        _PWM2_Init+0, 0
;PWM_LED.mbas,41 :: 		PWM2_Start()             ' start PWM2
	CALL        _PWM2_Start+0, 0
;PWM_LED.mbas,42 :: 		PWM2_Set_Duty(duty_cycle)' Set current duty for PWM2
	MOVF        _duty_cycle+0, 0 
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;PWM_LED.mbas,44 :: 		while true
L__main6:
;PWM_LED.mbas,45 :: 		while Button(PORTA,3, 20, 0)         ' test push button pressed
L__main11:
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       3
	MOVWF       FARG_Button_pin+0 
	MOVLW       20
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main12
;PWM_LED.mbas,46 :: 		delay_ms(250)                        ' short or long time
	MOVLW       4
	MOVWF       R11, 0
	MOVLW       44
	MOVWF       R12, 0
	MOVLW       171
	MOVWF       R13, 0
L__main15:
	DECFSZ      R13, 1, 1
	BRA         L__main15
	DECFSZ      R12, 1, 1
	BRA         L__main15
	DECFSZ      R11, 1, 1
	BRA         L__main15
	NOP
	NOP
;PWM_LED.mbas,47 :: 		if Button(PORTA,3, 20, 0) then    ' long time then dimming
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       3
	MOVWF       FARG_Button_pin+0 
	MOVLW       20
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main17
;PWM_LED.mbas,48 :: 		while Button(PORTA,3, speed, 0)
L__main20:
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	MOVLW       3
	MOVWF       FARG_Button_pin+0 
	MOVF        _speed+0, 0 
	MOVWF       FARG_Button_time+0 
	CLRF        FARG_Button_activeState+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__main21
;PWM_LED.mbas,49 :: 		if duty_cycle > 65 then         ' no linear curve eyes dimming
	MOVF        _duty_cycle+0, 0 
	SUBLW       65
	BTFSC       STATUS+0, 0 
	GOTO        L__main25
;PWM_LED.mbas,50 :: 		speed = 15
	MOVLW       15
	MOVWF       _speed+0 
	GOTO        L__main26
;PWM_LED.mbas,51 :: 		else
L__main25:
;PWM_LED.mbas,52 :: 		speed = 50
	MOVLW       50
	MOVWF       _speed+0 
;PWM_LED.mbas,53 :: 		end if
L__main26:
;PWM_LED.mbas,54 :: 		if increase = 1 then            ' up or down dimming
	BTFSS       _increase+0, BitPos(_increase+0) 
	GOTO        L__main28
;PWM_LED.mbas,55 :: 		if  duty_cycle < 255 then
	MOVLW       255
	SUBWF       _duty_cycle+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__main31
;PWM_LED.mbas,56 :: 		inc (duty_cycle)
	INCF        _duty_cycle+0, 1 
L__main31:
;PWM_LED.mbas,57 :: 		end if
L__main28:
;PWM_LED.mbas,59 :: 		if increase = 0 then
	BTFSC       _increase+0, BitPos(_increase+0) 
	GOTO        L__main34
;PWM_LED.mbas,60 :: 		if  duty_cycle > 0 then
	MOVF        _duty_cycle+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main37
;PWM_LED.mbas,61 :: 		dec (duty_cycle)
	DECF        _duty_cycle+0, 1 
L__main37:
;PWM_LED.mbas,62 :: 		end if
L__main34:
;PWM_LED.mbas,64 :: 		PWM2_Set_Duty(duty_cycle)
	MOVF        _duty_cycle+0, 0 
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;PWM_LED.mbas,65 :: 		EEPROM_WRITE(1,duty_cycle)       ' save duty_cycle in EEPROM
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _duty_cycle+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;PWM_LED.mbas,66 :: 		wend
	GOTO        L__main20
L__main21:
;PWM_LED.mbas,67 :: 		increase = not increase
	BTG         _increase+0, BitPos(_increase+0) 
;PWM_LED.mbas,68 :: 		EEPROM_WRITE(2,increase)          ' save up/down status in EEPROM
	MOVLW       2
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVLW       0
	BTFSC       _increase+0, BitPos(_increase+0) 
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
	GOTO        L__main18
;PWM_LED.mbas,69 :: 		else                              ' push button pressed short time ON/OFF function
L__main17:
;PWM_LED.mbas,70 :: 		if duty_cycle > 0 then          ' ON state then OFF
	MOVF        _duty_cycle+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__main40
;PWM_LED.mbas,71 :: 		duty_cycle_mem = duty_cycle     ' save value before OFF
	MOVF        _duty_cycle+0, 0 
	MOVWF       _duty_cycle_mem+0 
;PWM_LED.mbas,72 :: 		duty_cycle = 0
	CLRF        _duty_cycle+0 
	GOTO        L__main41
;PWM_LED.mbas,73 :: 		else
L__main40:
;PWM_LED.mbas,74 :: 		duty_cycle =  duty_cycle_mem    ' OFF state then ON at latest value
	MOVF        _duty_cycle_mem+0, 0 
	MOVWF       _duty_cycle+0 
;PWM_LED.mbas,75 :: 		end if
L__main41:
;PWM_LED.mbas,76 :: 		PWM2_Set_Duty(duty_cycle)
	MOVF        _duty_cycle+0, 0 
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;PWM_LED.mbas,77 :: 		EEPROM_WRITE(1,duty_cycle)
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _duty_cycle+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;PWM_LED.mbas,78 :: 		EEPROM_WRITE(3,duty_cycle_mem)
	MOVLW       3
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _duty_cycle_mem+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;PWM_LED.mbas,79 :: 		end if
L__main18:
;PWM_LED.mbas,80 :: 		wend
	GOTO        L__main11
L__main12:
;PWM_LED.mbas,81 :: 		wend
	GOTO        L__main6
L_end_main:
	GOTO        $+0
; end of _main
